from collections.abc import Sequence
from typing import overload


class AxisRx16:
    def __init__(self, clk: Signal8, rst: Signal8, s_axis_tdata: Signal16, s_axis_tvalid: Signal8, s_axis_tready: Signal8, s_axis_tid: Signal8 | None = None) -> None: ...

    @property
    def tready(self) -> int: ...

    @tready.setter
    def tready(self, value: int) -> None: ...

    def read(self, clear: bool = True) -> list[int]: ...

    def read_tid(self, clear: bool = True) -> list[int]: ...

class AxisRx32:
    def __init__(self, clk: Signal8, rst: Signal8, s_axis_tdata: Signal32, s_axis_tvalid: Signal8, s_axis_tready: Signal8, s_axis_tid: Signal8 | None = None) -> None: ...

    @property
    def tready(self) -> int: ...

    @tready.setter
    def tready(self, value: int) -> None: ...

    def read(self, clear: bool = True) -> list[int]: ...

    def read_tid(self, clear: bool = True) -> list[int]: ...

class AxisRx64:
    def __init__(self, clk: Signal8, rst: Signal8, s_axis_tdata: Signal64, s_axis_tvalid: Signal8, s_axis_tready: Signal8, s_axis_tid: Signal8 | None = None) -> None: ...

    @property
    def tready(self) -> int: ...

    @tready.setter
    def tready(self, value: int) -> None: ...

    def read(self, clear: bool = True) -> list[int]: ...

    def read_tid(self, clear: bool = True) -> list[int]: ...

class AxisRx8:
    def __init__(self, clk: Signal8, rst: Signal8, s_axis_tdata: Signal8, s_axis_tvalid: Signal8, s_axis_tready: Signal8, s_axis_tid: Signal8 | None = None) -> None: ...

    @property
    def tready(self) -> int: ...

    @tready.setter
    def tready(self, value: int) -> None: ...

    def read(self, clear: bool = True) -> list[int]: ...

    def read_tid(self, clear: bool = True) -> list[int]: ...

class AxisTx16:
    def __init__(self, clk: Signal8, rst: Signal8, m_axis_tdata: Signal16, m_axis_tvalid: Signal8, m_axis_tready: Signal8, m_axis_tid: Signal8 | None = None, tid_pattern: Sequence[int] = [0]) -> None: ...

    @overload
    def write(self, data: int) -> None: ...

    @overload
    def write(self, data: Sequence[int]) -> None: ...

    @overload
    def write(self, data: float, q: int = 0) -> None: ...

    @overload
    def write(self, data: Sequence[float], q: int = 0) -> None: ...

class AxisTx32:
    def __init__(self, clk: Signal8, rst: Signal8, m_axis_tdata: Signal32, m_axis_tvalid: Signal8, m_axis_tready: Signal8, m_axis_tid: Signal8 | None = None, tid_pattern: Sequence[int] = [0]) -> None: ...

    @overload
    def write(self, data: int) -> None: ...

    @overload
    def write(self, data: Sequence[int]) -> None: ...

    @overload
    def write(self, data: float, q: int = 0) -> None: ...

    @overload
    def write(self, data: Sequence[float], q: int = 0) -> None: ...

class AxisTx64:
    def __init__(self, clk: Signal8, rst: Signal8, m_axis_tdata: Signal64, m_axis_tvalid: Signal8, m_axis_tready: Signal8, m_axis_tid: Signal8 | None = None, tid_pattern: Sequence[int] = [0]) -> None: ...

    @overload
    def write(self, data: int) -> None: ...

    @overload
    def write(self, data: Sequence[int]) -> None: ...

    @overload
    def write(self, data: float, q: int = 0) -> None: ...

    @overload
    def write(self, data: Sequence[float], q: int = 0) -> None: ...

class AxisTx8:
    def __init__(self, clk: Signal8, rst: Signal8, m_axis_tdata: Signal8, m_axis_tvalid: Signal8, m_axis_tready: Signal8, m_axis_tid: Signal8 | None = None, tid_pattern: Sequence[int] = [0]) -> None: ...

    @overload
    def write(self, data: int) -> None: ...

    @overload
    def write(self, data: Sequence[int]) -> None: ...

    @overload
    def write(self, data: float, q: int = 0) -> None: ...

    @overload
    def write(self, data: Sequence[float], q: int = 0) -> None: ...

class Clock(Signal8):
    def __init__(self, period: float) -> None: ...

    @property
    def period(self) -> int: ...

class Context:
    def __init__(self, time_unit: float = 1e-09, time_precision: float = 1e-09) -> None: ...

    def __enter__(self) -> Context: ...

    def __exit__(self, exc_type: object | None = None, exc_value: object | None = None, traceback: object | None = None) -> None: ...

    def set_timescale(self, time_unit: float, time_precision: float) -> None: ...

    @property
    def time_unit(self) -> float: ...

    @time_unit.setter
    def time_unit(self, time_unit: float) -> None: ...

    @property
    def time_precision(self) -> float: ...

    @time_precision.setter
    def time_precision(self, time_precision: float) -> None: ...

    @property
    def time_step(self) -> int: ...

    def time(self) -> int: ...

    def clear(self) -> None: ...

    def elaborate(self) -> None: ...

    @property
    def elaborate_done(self) -> bool: ...

    def eval(self) -> None: ...

    def advance(self, time_inc: int = 1) -> None: ...

    def own_model(self, model: Model) -> None: ...

    @property
    def models(self) -> list[Model]: ...

    def print_info(self) -> str: ...

class ContextFactory:
    def create(self) -> Context: ...

    def obtain(self) -> Context: ...

    def reset(self) -> None: ...

class Dff16(Signal16):
    def __init__(self, clk: Signal8, initial: int = 0) -> None: ...

class Dff32(Signal32):
    def __init__(self, clk: Signal8, initial: int = 0) -> None: ...

class Dff64(Signal64):
    def __init__(self, clk: Signal8, initial: int = 0) -> None: ...

class Dff8(Signal8):
    def __init__(self, clk: Signal8, initial: int = 0) -> None: ...

class Model:
    def __init__(self) -> None: ...

    @property
    def context(self) -> Context: ...

    def eval_step(self) -> None: ...

    def eval_end_step(self) -> None: ...

    port_info: str = ...
    """(arg: object, /) -> str"""

class Signal16:
    def __init__(self, initial: int = 0) -> None: ...

    def posedge(self) -> bool: ...

    def negedge(self) -> bool: ...

    def changed(self) -> bool: ...

    @property
    def d(self) -> int: ...

    @d.setter
    def d(self, value: int) -> None: ...

    @property
    def q(self) -> int: ...

class Signal32:
    def __init__(self, initial: int = 0) -> None: ...

    def posedge(self) -> bool: ...

    def negedge(self) -> bool: ...

    def changed(self) -> bool: ...

    @property
    def d(self) -> int: ...

    @d.setter
    def d(self, value: int) -> None: ...

    @property
    def q(self) -> int: ...

class Signal64:
    def __init__(self, initial: int = 0) -> None: ...

    def posedge(self) -> bool: ...

    def negedge(self) -> bool: ...

    def changed(self) -> bool: ...

    @property
    def d(self) -> int: ...

    @d.setter
    def d(self, value: int) -> None: ...

    @property
    def q(self) -> int: ...

class Signal8:
    def __init__(self, initial: int = 0) -> None: ...

    def posedge(self) -> bool: ...

    def negedge(self) -> bool: ...

    def changed(self) -> bool: ...

    @property
    def d(self) -> int: ...

    @d.setter
    def d(self, value: int) -> None: ...

    @property
    def q(self) -> int: ...

def global_context() -> ContextFactory: ...

def link_context(global_context: ContextFactory) -> None: ...
